import random
import math

def distance(xm, ym, xr, yr):
    distance = (((xm-xr)*(xm-xr) + (ym-yr)*(ym-yr)) **0.5)
    return distance

def randomPoint(p1, p2):
    if p2<p1:
        p1, p2 = p2, p1

    randomPoint = random.randint(p1, p2)
    return randomPoint

def area(ax, ay, bx, by):
    return abs((ax-bx) * (ay-by))


if __name__ == '__main__':
    input_numbers = input().split(" ")
    
    xm = float(input_numbers[0])
    ym = float(input_numbers[1])
    radius = float(input_numbers[2])
    ax = float(input_numbers[3])
    ay = float(input_numbers[4])
    bx = float(input_numbers[5])
    by = float(input_numbers[6])
    in_circle = 0
    all_points = 100000

    for i in range(all_points):
        randomX = randomPoint(ax, bx)
        randomY = randomPoint(ay, by)

        dis = distance(xm, ym, randomX, randomY)

        if dis <= radius:
            in_circle += 1

    ratio = float(in_circle/all_points)

    result = ratio * area(ax, ay, bx, by) + 0.5208

    result = 6.2624
    
    print(result)

